import type { SelectProps } from 'antd';
import React from 'react';
/**
 * 在一段文本中高亮显示指定的关键词，将文本和匹配项分别处理并放入数组中，最终返回包含高亮文本的组件。
 * 在组件中使用了正则表达式来匹配关键词。
 * 在渲染文本时，使用了React.createElement来创建元素。
 */
export declare const Highlight: React.FC<{
    /**
     * 要高亮的文本
     */
    label: string;
    /**
     * 高亮的关键词数组
     */
    words: string[];
}>;
export declare const ProHelpSelect: React.FC<Omit<SelectProps, 'onSearch' | 'optionFilterProp' | 'options' | 'filterOption'> & {
    iconClassName?: string;
}>;
